=== Tests/Policy0002/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(Policy0002 C)
cmake_policy(SET CMP0002 OLD)
add_subdirectory(A)
add_executable(Policy0002 policy0002.c)
