=== debian/changelog ===
cmake (3.31.6-2ubuntu6) questing; urgency=medium

  * Re-enable tests on arm64
  * Merge changes from Debian unstable:
    - Sanitize test environment
    - Fix FTBFS with curl 8.16+
    - Allow host prefix for GNU as (Closes: #1115461)
    - Prevent test suite failures if a '+' is in the source path

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 20 Sep 2025 13:30:25 +0000

cmake (3.31.6-2ubuntu5) questing; urgency=medium

  * Rebuild to include updated RISC-V base ISA RVA23

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Sat, 13 Sep 2025 16:03:33 +0000

cmake (3.31.6-2ubuntu4) questing; urgency=medium

  * Make boost 1.89 a known version.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 09 Aug 2025 22:01:31 +0200

cmake (3.31.6-2ubuntu3) questing; urgency=medium

  * Ignore test results on arm64 for a first build. See LP #2119445.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 08 Aug 2025 19:40:47 +0200

cmake (3.31.6-2ubuntu2) questing; urgency=medium

  * Make boost 1.88 a known version.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 08 Aug 2025 08:19:19 +0200

cmake (3.31.6-2ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2111544). Remaining changes:
    - d/rules, d/control: do not build the GUI for i386

 -- Ural Tunaboyu <ural.tunaboyu@canonical.com>  Thu, 22 May 2025 22:01:25 -0700

cmake (3.31.6-2) unstable; urgency=medium

  * Avoid using undocumented type fo CURLOPT_NETRC values (Closes: #1101604)

 -- Timo Röhling <roehling@debian.org>  Mon, 31 Mar 2025 16:09:14 +0200

cmake (3.31.6-1ubuntu1) plucky; urgency=medium

  * Merge from Debian Unstable. Remaining changes:
    - Do not build the GUI on i386.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Wed, 05 Mar 2025 14:54:17 -0600

cmake (3.31.6-1) unstable; urgency=medium

  * New upstream version 3.31.6
  * Bump Standards-Version to 4.7.1

 -- Timo Röhling <roehling@debian.org>  Tue, 25 Feb 2025 09:21:18 +0100

cmake (3.31.5-2ubuntu3) plucky; urgency=medium

  * Do not build the GUI on i386.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sun, 09 Feb 2025 12:07:03 -0600
