=== debian/watch ===
version=4
opts="uversionmangle=s/-RC-?/~rc/i" \
  https://cmake.org/files/LatestRelease/ cmake-([\d.]+(?i:-RC-?\d+)?)@ARCHIVE_EXT@
